using System;
using System.Collections;
using Server.Items;
using Server.Targeting;

namespace Server.Mobiles
{
	[CorpseName( "a fairy dragon corpse" )]
	public class FairyDragon : BaseCreature
	{
		[Constructable]
		public FairyDragon() : base( AIType.AI_Mage, FightMode.Closest, 10, 1, 0.2, 0.4 )
		{
			Name = "a fairy dragon";
			Body = 718;
			BaseSoundID = 0x467;//Guessing

			SetStr( 506, 561 );
			SetDex( 97, 103 );
			SetInt( 401, 580 );

			SetHits( 393, 409 );

			SetDamage( 15, 20 );

			SetDamageType( ResistanceType.Cold, 25 );
			SetDamageType( ResistanceType.Poison, 25 );
			SetDamageType( ResistanceType.Fire, 25 );
			SetDamageType( ResistanceType.Energy, 25 );

			SetResistance( ResistanceType.Physical, 18, 29 );
			SetResistance( ResistanceType.Fire, 42, 48 );
			SetResistance( ResistanceType.Cold, 43, 50 );
			SetResistance( ResistanceType.Poison, 43, 45 );
			SetResistance( ResistanceType.Energy, 40, 46 );

			SetSkill( SkillName.EvalInt, 96.3 );
			SetSkill( SkillName.Magery, 96.9 );
			SetSkill( SkillName.MagicResist, 120.2, 125.0 );
			SetSkill( SkillName.Anatomy, 65.6, 73.6 );
			SetSkill( SkillName.Tactics, 94.3, 98.5 );
			SetSkill( SkillName.Wrestling, 83.1, 89.9 );

			Fame = 15000;
			Karma = 15000;

			VirtualArmor = 90;
		}

		public override void GenerateLoot()
		{
			AddLoot( LootPack.FilthyRich, 2 );
			AddLoot( LootPack.Rich );
			AddLoot( LootPack.MedScrolls, 2 );
		}

		public override int Meat{ get{ return 1; } }
		public override MeatType MeatType{ get{ return MeatType.Bird; } }
		public override int Hides{ get{ return 7; } }
		public override HideType HideType{ get{ return HideType.Barbed; } }
		public override FoodType FavoriteFood{ get{ return FoodType.Meat; } }

		public FairyDragon( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );
			writer.Write( (int) 0 );
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );
			int version = reader.ReadInt();
		}
	}
}