using System;
using Server.Mobiles;

namespace Server.Mobiles
{
	[CorpseName( "a giant rat corpse" )]
	public class ClanRibbonPlagueRat : BaseCreature
	{
		[Constructable]
		public ClanRibbonPlagueRat() : base( AIType.AI_Melee, FightMode.Closest, 10, 1, 0.2, 0.4 )
		{
			Name = "a clan ribbon plague rat";
			Body = 0xD7;
			Hue = 1118;
			BaseSoundID = 0x188;

			SetStr( 59 );
			SetDex( 51 );
			SetInt( 17 );

			SetHits( 92 );

			SetDamage( 4, 8 );

			SetDamageType( ResistanceType.Physical, 100 );

			SetResistance( ResistanceType.Physical, 37 );
			SetResistance( ResistanceType.Fire, 22 );
			SetResistance( ResistanceType.Poison, 44 );

			SetSkill( SkillName.MagicResist, 27.2 );
			SetSkill( SkillName.Tactics, 34.9 );
			SetSkill( SkillName.Wrestling, 40.5 );

			Fame = 300;
			Karma = -300;

			VirtualArmor = 18;;
		}

		public override void GenerateLoot()
		{
			AddLoot( LootPack.Poor );
		}

		public override int Meat{ get{ return 1; } }
		public override int Hides{ get{ return 6; } }
		public override FoodType FavoriteFood{ get{ return FoodType.Fish | FoodType.Meat | FoodType.FruitsAndVegies | FoodType.Eggs; } }

		public ClanRibbonPlagueRat(Serial serial) : base(serial)
		{
		}

		public override void Serialize(GenericWriter writer)
		{
			base.Serialize(writer);

			writer.Write((int) 0);
		}

		public override void Deserialize(GenericReader reader)
		{
			base.Deserialize(reader);

			int version = reader.ReadInt();
		}
	}
}