using System;
using Server.Mobiles;

namespace Server.Mobiles
{
	[CorpseName( "a wolf corpse" )]
	public class  ClanScratchSavageWolf : BaseCreature
	{
		[Constructable]
		public  ClanScratchSavageWolf() : base( AIType.AI_Melee, FightMode.Closest, 10, 1, 0.2, 0.4 )
		{
			Name = "a  clan scratch savage wolf";
			Body = 25;
			Hue = 1607;
			BaseSoundID = 0xE5;

			SetStr( 170 );
			SetDex( 244 );
			SetInt( 57 );

			SetHits( 65 );
			SetMana( 57 );

			SetDamage( 8, 10 );

			SetDamageType( ResistanceType.Physical, 100 );

			SetResistance( ResistanceType.Physical, 31 );
			SetResistance( ResistanceType.Fire, 41 );
			SetResistance( ResistanceType.Cold, 27 );
			SetResistance( ResistanceType.Poison, 26 );
			SetResistance( ResistanceType.Energy, 20 );

			SetSkill( SkillName.MagicResist, 41.9 );
			SetSkill( SkillName.Tactics, 42.6 );
			SetSkill( SkillName.Wrestling, 42.3 );

			Fame = 450;
			Karma = 0;

			VirtualArmor = 16;
		}

		public override int Meat{ get{ return 1; } }
		public override int Hides{ get{ return 6; } }
		public override FoodType FavoriteFood{ get{ return FoodType.Meat; } }
		public override PackInstinct PackInstinct{ get{ return PackInstinct.Canine; } }

		public  ClanScratchSavageWolf(Serial serial) : base(serial)
		{
		}

		public override void Serialize(GenericWriter writer)
		{
			base.Serialize(writer);

			writer.Write((int) 0);
		}

		public override void Deserialize(GenericReader reader)
		{
			base.Deserialize(reader);

			int version = reader.ReadInt();
		}
	}
}